#include "nodeitem.h"
#include <algorithm>

NodeItem::NodeItem( NodeItem *parent_ ) :
  parent    ( parent_  ),
  childs    (          ),
  sourceIdx ( 0 )
{
  if( parent )
  {
    parent->childs.push_back( this );
    sourceIdx = parent->childs.size();
  }
}

NodeItem::~NodeItem()
{
  clearChilds();

  if( parent )
  {
    std::vector<NodeItem*>::iterator it = std::find( parent->childs.begin(), parent->childs.end(), this );
    if ( it != parent->childs.end() )
    {
      parent->childs.erase( it );
    }
  }
}


size_t NodeItem::rowCount() const
{
  return childs.size();
}

NodeItem* NodeItem::parentItem() const
{
  return parent;
}

size_t NodeItem::row() const
{
  if( parent )
    return find( parent->childs.begin(), parent->childs.end(), this ) - parent->childs.begin();
  return 0;
}

NodeItem* NodeItem::child( size_t row )
{
  return childs[ row ];
}

void NodeItem::clearChilds()
{
  for( std::vector<NodeItem*>::reverse_iterator it = childs.rbegin(); it != childs.rend(); ++it )
  {
    delete *it;
  }
}


