#include "widget.h"

void Widget::addObjAction()
{
  model->addObject();
}

void Widget::remObjAction()
{
  WModelIndexSet list = table->selectedIndexes();
  if( list.size() == 1 )
  {
    model->remObject( static_cast<NodeItem*>( ( *list.begin() ).internalPointer() ) );
  }
}

//-------------------------------------------------------------------------------------
// Dsc:
//-------------------------------------------------------------------------------------
Widget::Widget( WContainerWidget *parent ) :
  WContainerWidget( parent   ),
  container       ( new WContainerWidget( this ) ),
  addObj          ( new WPushButton( "+", this ) ),
  remObj          ( new WPushButton( "-", this ) ),
  table     ( new WTreeView( this ) ),
  model     ( new Model( table ) )
{
  this->setWidth( 300 );
  this->addWidget( container );
  container->setLayout( new WHBoxLayout( container ) );
  container->layout()->addWidget( addObj );
  container->layout()->addWidget( remObj );
  this->addWidget       ( table );
  table->setModel ( model );
  table->setSelectionMode    ( Wt::SingleSelection);
  table->setSelectionBehavior( Wt::SelectRows     );
  table->setEditTriggers     ( WAbstractItemView::NoEditTrigger);

  addObj->clicked().connect ( this, &Widget::addObjAction );
  remObj->clicked().connect ( this, &Widget::remObjAction );
}

//-------------------------------------------------------------------------------------
// Dsc:
//-------------------------------------------------------------------------------------
Widget::~Widget()
{

}
